<template lang="pug">
    .actions-right
        ul.stats
            li(:class="{ voted: votedByUser }")
                v-popover(:disabled="!isLoggedIn" )
                    a.action-vote.icon.solid.fa-heart(:class="{ voted: votedByUser }" :title="iconTitle") {{ votersCount }}
                    VotingSlider(slot="popover" :author="article.author" :permlink="article.permlink" @success="getParams()")
            li
                a.action-vote.icon.solid.fa-hand-holding-usd ${{ value.toFixed(2) }}

</template>

<script lang="ts">
    import Vue from "vue";
    import Vuex from 'vuex';
    import VotingService from "../../services/VotingService";
    import VotingSlider from './VotingSlider'

    export default Vue.extend({

        components: {
            VotingSlider
        },

        props: {
            article: {
                type: Object,
                required: true
            }
        },

        data() {
            return {
                voters: [],
                value: 0
            }
        },

        computed: {
            votersCount() {
                return this.voters ? this.voters.length : 0;
            },
            iconTitle() {
                return this.votedByUser ? 'Already voted' : 'Vote'
            },
            isLoggedIn() {
                return this.$store.state.sso.loggedIn;
            },
            username() {
                return this.$store.state.sso.username;
            },
            votedByUser() {
                return this.voters ? this.voters.reduce( (voted: boolean, vote: any) => (voted || vote.voter === this.username), false) : false;
            }
        },

        methods: {
            getVoters() {
                VotingService.getVotes(this.article.author, this.article.permlink)
                    .then((voters: any[]) => {
                        this.voters = voters;
                    })
            },
            getValue() {
                VotingService.getValue(this.article.author, this.article.permlink)
                    .then( (value: number) => {
                        this.value = value;
                    })
            },
            getParams() {
                this.getVoters();
                this.getValue();
            }
        },

        mounted() {
            this.getParams();
        }
    });
</script>

<style scoped>
    .voted {
        color: green !important;
    }
    .voted :before {
        color: green !important;
    }
    .action-vote {
        cursor: pointer;
    }
</style>
